/*
 * Copyright (c) 2022, SHANGHAI FUDAN MICROELECTRONICS GROUP CO., LTD.(FUDAN MICROELECTRONICS./ FUDAN MICRO.)
 * All rights reserved.
 *
 * Processor:                   FM33LE0xxA
 * http:                        http://www.fmdevelopers.com.cn/
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 *
 * 3. Neither the name of the copyright holder nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * 4. To provide the most up-to-date information, the revision of our documents 
 *    on the World Wide Web will be the most Current. Your printed copy may be  
 *    an earlier revision. To verify you have the latest information avaliable,
 *    refer to: http://www.fmdevelopers.com.cn/.
 *
 * THIS SOFTWARE IS PROVIDED BY FUDAN MICRO "AS IS" AND ANY EXPRESSED 
   ORIMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
   OF MERCHANTABILITY NON-INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE
   ARE DISCLAIMED.IN NO EVENT SHALL FUDAN MICRO OR ITS CONTRIBUTORS BE LIABLE 
   FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
   DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS 
   OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
   CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, 
   OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISINGIN ANY WAY OUT OF THE 
   USE OF THIS SOFTWARE, EVEN IF ADVISED OFTHE POSSIBILITY OF SUCH DAMAGE.
*/
/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __BOOTLOADER_H
#define __BOOTLOADER_H
/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "lin.h"
/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
#define ENCRYPT 0       //̼ǷܣΪ1ôҪappйѡ"After Build/Rebuild"µ"Run #1""Run #2"ѡ
#define APP_START_ADDR             ((uint32_t)0x00008000)//APPʼַ
#define APP_EXE_FLAG_ADDR          ((uint32_t)0x00004000)//APPб־洢ַñ־APPдͲ
//ֵ̼
#define FW_TYPE_BOOT     0x55
#define FW_TYPE_APP      0xAA
//嵱ǰ̼ΪBOOT
#define FW_TYPE         FW_TYPE_BOOT
//շ֡IDλһ£޷
//շ֡ID,0-׼֡1-չ֡
#define MSG_ID_TYPE         0
#if (MSG_ID_TYPE == 0) //׼֡
    //CANߣշIDԶΪһIDҲԶΪͬID
    #define MSG_RECEIVE_ID      0x3C
    #define MSG_SEND_ID         0x3D
#else //չ֡
    //CANߣշIDԶΪһIDҲԶΪͬID
    #define MSG_RECEIVE_ID      0x12345
    #define MSG_SEND_ID         0x12346
#endif
//ڵ㲥ַ
#define NAD_BROADCAST           0x7F
//BOOT
#define CMD_GET_FW_INFO         0x80
#define CMD_ENTER_BOOT          0xC1
#define CMD_ERASE_APP           0x42
#define CMD_SET_ADDR_OFFSET     0x03
#define CMD_TRAN_DATA           0xC4
#define CMD_WRITE_DATA          0x85
#define CMD_ENTER_APP           0x06
//BOOT
#define BOOT_ERR_SUCCESS        0   //ûд
#define BOOT_ERR_ERASE          1   //̼
#define BOOT_ERR_ERASE_IN_APP   2   //ǰģʽΪAPP̼ܲ
#define BOOT_ERR_WRITE_OUTRANGE 3   //ǰַĵַΧ
#define BOOT_ERR_WRITE_IN_APP   4   //ǰģʽд̼
#define BOOT_ERR_WRITE          5   //д洢
#define BOOT_ERR_WRITE_OUT_ADDR 6   //ݳȳ˳洢Χ 
#define BOOT_ERR_TRAN_CRC       7   //ݴCRCУ
#define BOOT_ERR_WRITE_CRC      8   //доƬCRCУ
/* Private variables ---------------------------------------------------------*/
extern volatile uint8_t BOOT_MsgIndex;
extern BootRxMsg BOOT_RxMessage[2];
extern volatile uint8_t BootRxMsgFlag;//յݺı־
/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/
FLASH_Status BOOT_ErasePage(uint32_t StartPageAddr, uint32_t EndPageAddr);
uint16_t BOOT_GetAddrData(void);
void BOOT_ExecutiveCommand(BootRxMsg *pRxMessage);
void BOOT_JumpToApplication(__IO uint32_t Addr);
void BOOT_Configuration(void);
uint8_t BOOT_SendData(uint8_t *data, uint8_t len);
uint8_t GetNAD(void);
#endif
/*********************************END OF FILE**********************************/

