/*
 * Copyright (c) 2022, SHANGHAI FUDAN MICROELECTRONICS GROUP CO., LTD.(FUDAN MICROELECTRONICS./ FUDAN MICRO.)
 * All rights reserved.
 *
 * Processor:                   FM33LE0xxA
 * http:                        http://www.fmdevelopers.com.cn/
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 *
 * 3. Neither the name of the copyright holder nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * 4. To provide the most up-to-date information, the revision of our documents 
 *    on the World Wide Web will be the most Current. Your printed copy may be  
 *    an earlier revision. To verify you have the latest information avaliable,
 *    refer to: http://www.fmdevelopers.com.cn/.
 *
 * THIS SOFTWARE IS PROVIDED BY FUDAN MICRO "AS IS" AND ANY EXPRESSED 
   ORIMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
   OF MERCHANTABILITY NON-INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE
   ARE DISCLAIMED.IN NO EVENT SHALL FUDAN MICRO OR ITS CONTRIBUTORS BE LIABLE 
   FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
   DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS 
   OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
   CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, 
   OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISINGIN ANY WAY OUT OF THE 
   USE OF THIS SOFTWARE, EVEN IF ADVISED OFTHE POSSIBILITY OF SUCH DAMAGE.
*/
#include "main.h"
#include "fm33le0xxa_fl.h"
#include "uart.h"
#include "lin.h" 
#include "user_init.h"
#include "sleep.h"
#include "iwdt.h"
#include "rmu.h"
#include "svd.h"

extern volatile uint8_t BOOT_MsgIndex;
extern BootRxMsg BOOT_RxMessage[2];
extern volatile uint8_t BootRxMsgFlag;//յBOOTݺı־


/**
  * @brief  HardFault жϷ 뱣 пע͵˲ִ룬HardFault޷λ
  * @param  void
  * @retval None
  */
void HardFault_Handler(void)
{
    /* ʹ */
    RMU_Soft_SystemReset();
}

/**
  * @brief  أִе¼
  * @param  void
  * @retval None
  */
static void PowerDownMonitoring(void)
{
    /* ȷSVDǷֵ */
    if (true == SVD_Result_Confirmed(SVD_BELOW_THRESHOLD, 1U))
    {   /*  */
        if (true == SVD_Result_Confirmed(SVD_BELOW_THRESHOLD, 2000U/*us*/))
        {
            /* ѹ½ֵ¼ */
            /* û1 */
            /* ...... */
            /* ע⣺ûȷBORλ֮ǰִ */
            
            
            /* ȷSVDǷֵȴ */
            while(false == SVD_Result_Confirmed(SVD_HIGHER_THRESHOLD, 20U/*us*/));
            /* ڵԴ½ֵλ³ʼ */
            RMU_Soft_SystemReset();
        }
    }
}

int main(void)
{   
    /*****************߿ɿԣIWDT/SVD/BOR*****************/
    /* ʹIWDT */
    IWDT_Init(FL_IWDT_PERIOD_4000MS);  /* ϵʼŹ߿ɿ */

    /* Initialize FL Driver Library */
    /* SHOULD BE KEPT!!! */
    FL_Init();
  
    /* ʹSVD, ֵ4.16V(falling)~4.284V(rising) */
    SVD_Init(SVD_MONTIOR_VDD, FL_SVD_WARNING_THRESHOLD_GROUP11, FL_SVD_REFERENCE_1P0V);
  
    /* ȷSVDǷֵȴȴѹ4.16Vִ */
    while(false == SVD_Result_Confirmed(SVD_HIGHER_THRESHOLD, 2000U/*us*/));
  
    /* ʹBOR BORλ1.75V*/
    RMU_BOR_Init(FL_RMU_BOR_THRESHOLD_1P75V);
    /*****************߿ɿԣIWDT/SVD/BOR*****************/
    /* Reset of all peripherals, Initializes the Flash interface and the Systick. */
    /* SHOULD BE KEPT!!! */
    MF_Clock_Init();
    
    /* Configure the system clock */
    /* SHOULD BE KEPT!!! */
    MF_SystemClock_Config();
    
    /* Initialize all configured peripherals */
    /* SHOULD BE KEPT!!! */
    MF_Config_Init();

    /* û */
    UserInit();

    if (*((uint32_t *)APP_EXE_FLAG_ADDR) == 0x78563412)
    {
        BOOT_JumpToApplication(APP_START_ADDR);
    }
    __set_PRIMASK(0);//ж
    
    BOOT_Configuration();

    while(1)
    {
        /* 幷 */
        IWDT_Clr();
        
        /* Դ⴦4.1VжӦ */
        PowerDownMonitoring();
      
      
        if (BootRxMsgFlag)
        {
            BOOT_ExecutiveCommand(&BOOT_RxMessage[BOOT_MsgIndex & 0x01]);
            BOOT_MsgIndex++;
            BootRxMsgFlag = 0;
        }
    }
}


